Index: palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4892)
+++ palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4893)
@@ -3947,87 +4060,288 @@
           glo_start = total_number_of_surface_values + 1
        ENDIF
-       total_number_of_surface_values = total_number_of_surface_values + all_nr_val(i)
+       total_number_of_surface_values = total_number_of_surface_values + nr_surfcells_all_r(i,1)
     ENDDO
-
-!
-!-- Actions during reading
-    IF ( rd_flag )  THEN
-
-#if defined( __parallel )
-       CALL MPI_FILE_SET_VIEW( fhs, offset, MPI_BYTE, MPI_BYTE, 'native', MPI_INFO_NULL, ierr )
-#endif
-    ENDIF
-
-    IF ( cyclic_fill_mode )  CALL mainrun_grid%activate_grid_from_this_class()
-
-!
-!-- Actions during writing
-    IF ( wr_flag )  THEN
-!
-!--    Create surface filetype
-       ft_surf      = -1
-       global_start = start_index + glo_start - 1
-
-       WHERE ( end_index < start_index )
-          global_start = -1
-       ENDWHERE
-
-#if defined( __parallel )
-       IF ( sm_io%is_sm_active() )  THEN
-          IF ( sm_io%iam_io_pe )  THEN
-!
-!--          Calculate number of values of all PEs of an I/O group
-             nr_iope = 0
-             DO  i = myid, myid+sm_io%sh_npes-1
-                nr_iope = nr_iope + all_nr_val(i)
+    only_dummy_values = ( MAXVAL( nr_surfcells_all_r(:,2) ) <= 0 )
+
+!
+!-- Compute indices of equally distributed surface elements.
+!-- Number of surface values scheduled for ouput on this PE:
+    nr_surfcells_pe  = total_number_of_surface_values  / numprocs
+    rest_cells_pe    = MOD( total_number_of_surface_values, numprocs )
+    rest_bound       = rest_cells_pe * ( nr_surfcells_pe + 1 )
+    m_start_index    = start_index
+    m_end_index      = end_index
+
+!
+!-- Compute number of elements on source PE, which have to be send to the corresponding target PE.
+#if defined( __parallel )
+    nr_cells_to_thread  = 0
+    nr_values_to_thread = 0
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          IF ( rest_cells_pe == 0 )  THEN
+             target_thread(j,i) = ( global_start(j,i) - 1 ) / nr_surfcells_pe
+          ELSE
+             IF ( global_start(j,i) <= rest_bound )  THEN
+                target_thread(j,i) = ( global_start(j,i) - 1 ) / ( nr_surfcells_pe + 1 )
+             ELSE
+                target_thread(j,i) = ( global_start(j,i) - rest_bound - 1 ) / nr_surfcells_pe
+                target_thread(j,i) = target_thread(j,i) + rest_cells_pe
+             ENDIF
+!
+!--          TODO: Test output, to be removed later.
+             IF ( target_thread(j,i) >= numprocs )  THEN
+                WRITE( 9,'(A,8I8)' )  'target_thread ', j, i, target_thread(j,i),                  &
+                                      global_start(j,i) , nr_surfcells_pe
+                FLUSH( 9 )
+                CALL MPI_ABORT( comm2d, 1, ierr )
+             ENDIF
+          ENDIF
+          nr_cells_to_thread(target_thread(j,i))  = nr_cells_to_thread(target_thread(j,i)) + 1
+          nr_values_to_thread(target_thread(j,i)) = nr_values_to_thread(target_thread(j,i)) +      &
+                                                    e_end_index(j,i) - e_start_index(j,i) + 1
+       ENDDO
+    ENDDO
+
+!
+!-- Compute start index in the transfer buffer on the source side for the corresponding target PE.
+    thread_index(0)  = 1
+    thread_values(0) = 1
+    DO  n = 1, numprocs-1
+       thread_index(n)  = thread_index(n-1) + nr_cells_to_thread(n-1)
+       thread_values(n) = thread_values(n-1) + nr_values_to_thread(n-1)
+    ENDDO
+!
+!-- Buffer distribution on the source side.
+    DO  n = 0, numprocs-1
+       transfer_index_s(1,n) = thread_index(n)
+       transfer_index_s(2,n) = nr_cells_to_thread(n)
+       transfer_index_s(3,n) = thread_values(n)
+       transfer_index_s(4,n) = nr_values_to_thread(n)
+    ENDDO
+
+    CALL MPI_ALLTOALL( transfer_index_s, 4, MPI_INTEGER, transfer_index, 4, MPI_INTEGER, comm2d,   &
+                       ierr)
+!
+!-- Buffer distribution on the target side side.
+    CALL get_remote_indices()
+!
+!-- Create surface element file type.
+    IF ( total_number_of_surface_values > 0 .AND. .NOT. only_dummy_values)  THEN
+        data_to_write = .TRUE.
+    ELSE
+        data_to_write = .FALSE.
+    ENDIF
+
+    CALL MPI_ALLREDUCE( global_end(nyn,nxr), dims1(1), 1, MPI_INTEGER, MPI_MAX, comm2d, ierr )
+    start1(1) = MINVAL( local_indices(1,:) ) - 1
+    IF ( sm_io%is_sm_active() )  THEN
+       CALL MPI_ALLREDUCE( SUM( local_indices(2,:) ), lsize1(1), 1, MPI_INTEGER, MPI_SUM,          &
+                           sm_io%comm_shared, ierr )
+    ELSE
+       lsize1(1) = SUM( local_indices(2,:) )
+    ENDIF
+
+    IF ( sm_io%iam_io_pe )  THEN
+       IF ( total_number_of_surface_values > 0 )  THEN
+           CALL MPI_TYPE_CREATE_SUBARRAY( 1, dims1, lsize1, start1, MPI_ORDER_FORTRAN, MPI_REAL,   &
+                                          ft_surf, ierr )
+           CALL MPI_TYPE_COMMIT( ft_surf, ierr )
+       ENDIF
+    ENDIF
+!
+!-- Allocate rma window to supply surface data to other PEs.
+    CALL rd_alloc_rma_mem( array_1d, SUM( nr_values_to_thread ), win_surf )
+!
+!-- Allocate shared array on IO-PE to supply data for MPI-IO (write or read).
+    IF ( sm_io%is_sm_active() )  THEN
+       IF ( sm_io%iam_io_pe )  THEN
+          io_start_index = start1(1) + 1
+          io_end_index   = start1(1) + lsize1(1)
+       ENDIF
+       CALL MPI_BCAST( io_start_index, 1, MPI_INTEGER, 0, sm_io%comm_shared, ierr )
+       CALL MPI_BCAST( io_end_index,   1, MPI_INTEGER, 0, sm_io%comm_shared, ierr )
+       CALL sm_io%sm_allocate_shared( array_out, io_start_index, io_end_index, win_out )
+    ELSE
+       ALLOCATE( array_out(start1(1)+1:start1(1)+lsize1(1)) )
+    ENDIF
+#else
+    IF ( total_number_of_surface_values > 0  .AND.  .NOT. only_dummy_values )  THEN
+        data_to_write = .TRUE.
+    ELSE
+        data_to_write = .FALSE.
+    ENDIF
+    ALLOCATE( array_out(1:total_number_of_surface_values) )
+#endif
+
+ CONTAINS
+
+    SUBROUTINE cyclic_fill_surface_filetype
+
+       INTEGER(iwp) ::  i  !<  loop index
+       INTEGER(iwp) ::  j  !<  loop index
+
+
+       IF ( .NOT. ALLOCATED( o_start_index ) )  ALLOCATE( o_start_index(nys:nyn,nxl:nxr) )
+       IF ( .NOT. ALLOCATED( o_end_index )   )  ALLOCATE( o_end_index(nys:nyn,nxl:nxr)   )
+
+       lo_start   = 1
+       DO  i = nxl, nxr
+           DO  j = nys, nyn
+               o_start_index(j,i) = lo_start
+               o_end_index(j,i)   = lo_start
+               lo_start           = lo_start + 1
+           ENDDO
+       ENDDO
+       start_index = o_start_index
+       end_index   = o_end_index
+
+       IF ( MAXVAL( global_end-global_start ) > 1 )  THEN
+          message_string = 'cylic-fill method does not allow more than one surface element ' //    &
+                           'per grid box'
+          CALL message( 'cyclic_fill_surface_filetype', 'PA0742', 1, 2, 0, 6, 0 )
+       ENDIF
+!
+!--    Activate grid of the smaller prerun, i.e. grid variables like nxl, nxr, nys, nyn and others
+!--    are set according to the prerun layout.
+       CALL prerun_grid%activate_grid_from_this_class()
+
+       IF ( pe_active_for_read )  THEN
+
+          IF ( .NOT. ALLOCATED( c_global_start ) )  ALLOCATE( c_global_start(nys:nyn,nxl:nxr) )
+          IF ( .NOT. ALLOCATED( c_global_end )   )  ALLOCATE( c_global_end(nys:nyn,nxl:nxr)   )
+          IF ( .NOT. ALLOCATED( c_start_index )  )  ALLOCATE( c_start_index(nys:nyn,nxl:nxr)  )
+          IF ( .NOT. ALLOCATED( c_end_index )    )  ALLOCATE( c_end_index(nys:nyn,nxl:nxr)    )
+
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                c_global_start(j,i) = global_start(j,i)
+                c_global_end(j,i)   = global_end(j,i)
              ENDDO
-          ELSE
-             local_start = 0
-             DO  i = myid-sm_io%sh_rank, myid-1
-                local_start = local_start + all_nr_val(i)
-             ENDDO
+          ENDDO
+!
+!--       Recursive call of rd_mpi_io_surface_filetypes.
+!--       Prerun data are read, but they are treated as if they are mainrun data, just on a smaller
+!--       grid.
+          cyclic_fill_mode = .FALSE.
+          CALL rd_mpi_io_surface_filetypes( c_start_index, c_end_index, data_to_write,             &
+                                            c_global_start, c_global_end )
+          cyclic_fill_mode = .TRUE.
+
+       ENDIF
+!
+!--    Activate grid of the mainrun, i.e. grid variables like nxl, nxr, nys, nyn and others
+!--    are set according to the mainrun layout.
+       CALL mainrun_grid%activate_grid_from_this_class()
+
+#if defined( __parallel )
+       CALL MPI_BCAST( data_to_write, 1, MPI_LOGICAL, 0, comm2d, ierr )
+#endif
+
+    END SUBROUTINE cyclic_fill_surface_filetype
+
+#if defined( __parallel )
+!
+!-- Get the indices of the surface elements inside the RMA window on the remote PE.
+!-- This information is required to fetch the surface element data on remote PEs
+!-- in rrd_mpi_io_surface and wrd_mpi_io_surface.
+    SUBROUTINE get_remote_indices
+
+       INTEGER(iwp) ::  buf_start  !<
+       INTEGER(iwp) ::  i          !<
+       INTEGER(iwp) ::  j          !<
+       INTEGER(iwp) ::  n          !<
+       INTEGER(iwp) ::  n_trans    !<
+       INTEGER(iwp) ::  win_ind    !<
+
+       INTEGER(KIND=MPI_ADDRESS_KIND) ::  disp     !< displacement in RMA window
+       INTEGER(KIND=MPI_ADDRESS_KIND) ::  winsize  !< size of RMA window
+
+       INTEGER(iwp), DIMENSION(0:numprocs-1) ::  lo_index         !<
+
+       INTEGER(iwp), POINTER, DIMENSION(:,:) ::  surf_val_index  !<
+
+
+       IF ( ALLOCATED( local_indices ) )  DEALLOCATE( local_indices )
+       ALLOCATE( local_indices(2,MAX( SUM( transfer_index(2,:) ), 2 )))
+
+       local_indices(1,:) = 0
+       local_indices(2,:) = 0
+
+       winsize = MAX( 2 * SUM( nr_cells_to_thread ), 2 )
+
+       ALLOCATE( surf_val_index(2,winsize) )
+       winsize = winsize * iwp
+       CALL MPI_WIN_CREATE( surf_val_index, winsize, iwp, MPI_INFO_NULL, comm2d, win_ind, ierr )
+       CALL MPI_WIN_FENCE( 0, win_ind, ierr )
+
+       lo_index = thread_index
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             surf_val_index(1,lo_index(target_thread(j,i))) = global_start(j,i)
+             surf_val_index(2,lo_index(target_thread(j,i))) = global_end(j,i) - global_start(j,i)  &
+                                                              + 1
+             lo_index(target_thread(j,i)) = lo_index(target_thread(j,i)) + 1
+          ENDDO
+       ENDDO
+
+       CALL MPI_WIN_FENCE( 0, win_ind, ierr )
+
+       buf_start = 1
+       DO  n = 0, numprocs-1
+          n_trans = transfer_index(2,n)
+          IF ( n_trans > 0 )  THEN
+             disp = 2 * ( transfer_index(1,n) - 1 )
+             CALL MPI_GET( local_indices(1,buf_start), 2*n_trans, MPI_INTEGER, n, disp, 2*n_trans, &
+                           MPI_INTEGER, win_ind, ierr )
+             buf_start = buf_start + n_trans
           ENDIF
-!
-!--       Get the size of shared memory window on all PEs
-          CALL MPI_BCAST( nr_iope, 1, MPI_INTEGER, 0, sm_io%comm_shared, ierr )
-          CALL sm_io%sm_allocate_shared( array_1d, 1, MAX( 1, nr_iope ), win_surf )
-       ELSE
-          nr_iope = nr_val
-       ENDIF
-#else
-       nr_iope = nr_val
-#endif
-
-!
-!--    Check, if surface data exist on this PE
-       data_to_write = .TRUE.
-       IF ( total_number_of_surface_values == 0 )  THEN
-          data_to_write = .FALSE.
-          RETURN
-       ENDIF
-
-       IF ( sm_io%iam_io_pe )  THEN
-
-          all_pes_write = ( MINVAL( all_nr_val ) > 0 )
-
-          IF ( all_pes_write )  THEN
-             dims1(1)  = total_number_of_surface_values
-             lize1(1)  = nr_iope
-             start1(1) = glo_start-1
-
-#if defined( __parallel )
-             IF ( total_number_of_surface_values > 0 )  THEN
-                 CALL MPI_TYPE_CREATE_SUBARRAY( 1, dims1, lize1, start1, MPI_ORDER_FORTRAN,        &
-                                                MPI_REAL, ft_surf, ierr )
-                 CALL MPI_TYPE_COMMIT( ft_surf, ierr )
-             ENDIF
-#endif
+       ENDDO
+
+       CALL MPI_WIN_FENCE( 0, win_ind, ierr )
+
+       buf_start = 1
+       DO  n = 0, numprocs-1
+          n_trans = transfer_index(2,n)
+          IF ( n_trans > 0 )  THEN
+             disp = transfer_index(1,n) - 1
+             buf_start = buf_start + n_trans
           ENDIF
-       ENDIF
-
-    ENDIF
+       ENDDO
+
+       CALL MPI_WIN_FREE( win_ind, ierr )
+
+       DEALLOCATE( surf_val_index )
+
+    END SUBROUTINE get_remote_indices
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Allocate memory and create window for one-sided communication (1-d INTEGER array)
+!--------------------------------------------------------------------------------------------------!
+    SUBROUTINE rd_alloc_rma_mem( array, idim, win )
+
+       IMPLICIT NONE
+
+       INTEGER(iwp), INTENT(IN)       ::  idim     !< Dimension of this 1-D array
+       INTEGER                        ::  ierr     !< MPI error code
+       INTEGER(iwp), INTENT(OUT)      ::  win      !< MPI window
+       INTEGER(KIND=MPI_ADDRESS_KIND) ::  winsize  !< size of RMA window
+
+       REAL(wp), DIMENSION(:), POINTER, INTENT(INOUT) ::  array  !< array to access RMA window locally
+
+
+       winsize = MAX( idim, 2 )
+       ALLOCATE( array(winsize) )
+       winsize = winsize * wp
+       CALL MPI_WIN_CREATE( array, winsize, wp, MPI_INFO_NULL, comm2d, win, ierr )
+       array = -1
+       CALL MPI_WIN_FENCE( 0, win, ierr )
+
+    END SUBROUTINE rd_alloc_rma_mem
+#endif
 
  END SUBROUTINE rd_mpi_io_surface_filetypes
-
 
 
@@ -4079,5 +4393,5 @@
           iog%nnx = iog%nnx + nbgp
        ENDIF
-       IF ( myidx == npex-1  .OR.  npex == -1 )  THEN   ! npex == 1 if -D__parallel not set
+       IF ( myidx == pdims(1)-1 )  THEN
           iog%nxr = iog%nxr + nbgp
           iog%nnx = iog%nnx + nbgp
@@ -4087,5 +4401,5 @@
           iog%nny = iog%nny + nbgp
        ENDIF
-       IF ( myidy == npey-1  .OR.  npey == -1 )  THEN   ! npey == 1 if -D__parallel not set
+       IF ( myidy == pdims(2)-1 )  THEN
           iog%nyn = iog%nyn + nbgp
           iog%nny = iog%nny + nbgp
@@ -4251,5 +4565,5 @@
           iog%nnx = iog%nnx + nbgp
        ENDIF
-       IF ( myidx == npex-1  .OR.  npex == -1 )  THEN   ! npex == 1 if -D__parallel not set
+       IF ( myidx == pdims(1)-1 )  THEN
           iog%nxr = iog%nxr + nbgp
           iog%nnx = iog%nnx + nbgp
@@ -4259,5 +4573,5 @@
           iog%nny = iog%nny + nbgp
        ENDIF
-       IF ( myidy == npey-1  .OR.  npey == -1 )  THEN   ! npey == 1 if -D__parallel not set
+       IF ( myidy == pdims(2)-1 )  THEN
           iog%nyn = iog%nyn + nbgp
           iog%nny = iog%nny + nbgp
@@ -4326,5 +4640,4 @@
 !> to a single file that contains the global arrays. It is not required for the serial mode.
 !--------------------------------------------------------------------------------------------------!
-#if defined( __parallel )
  SUBROUTINE rd_mpi_io_create_filetypes_3dsoil( nzb_soil, nzt_soil )
 
@@ -4334,4 +4647,5 @@
     INTEGER, INTENT(IN)   ::  nzt_soil  !<
 
+#if defined( __parallel )
     INTEGER, DIMENSION(3) ::  dims3     !<
     INTEGER, DIMENSION(3) ::  lize3     !<
@@ -4367,9 +4681,10 @@
        CALL MPI_TYPE_COMMIT( ft_3dsoil, ierr )
     ENDIF
+#else
+    ALLOCATE( array_3d_soil(nzb_soil:nzt_soil,iog%nxl:iog%nxr,iog%nys:iog%nyn) )
+    sm_io%io_grid = iog
+#endif
 
  END SUBROUTINE rd_mpi_io_create_filetypes_3dsoil
-#endif
-
-
 
 !--------------------------------------------------------------------------------------------------!
@@ -4381,5 +4696,4 @@
 
     IMPLICIT NONE
-
 
 #if defined( __parallel )
@@ -4401,4 +4715,5 @@
 
     ENDIF
+
 !
 !-- Free last surface filetype
@@ -4415,10 +4730,27 @@
     IF ( sm_io%iam_io_pe .AND. ft_3di4 /= -1 )  THEN
        CALL MPI_TYPE_FREE( ft_3di4, ierr )
+       ft_3di4 = -1
+    ENDIF
+    IF ( sm_io%iam_io_pe .AND. ft_3di8 /= -1 )  THEN
        CALL MPI_TYPE_FREE( ft_3di8, ierr )
+       ft_3di8 = -1
     ENDIF
 
     IF ( sm_io%is_sm_active() .AND.  win_3di4 /= -1 )  THEN
        CALL sm_io%sm_free_shared( win_3di4 )
+       win_3di4 = -1
+    ENDIF
+    IF ( sm_io%is_sm_active() .AND.  win_3di8 /= -1 )  THEN
        CALL sm_io%sm_free_shared( win_3di8 )
+       win_3di8 = -1
+    ENDIF
+
+    IF ( win_start /= -1 )  THEN
+       CALL sm_io%sm_free_shared( win_start)
+       CALL sm_io%sm_free_shared( win_end)
+       CALL sm_io%sm_free_shared( win_glost)
+       win_start = -1
+       win_end   = -1
+       win_glost = -1
     ENDIF
 
@@ -4426,9 +4758,9 @@
     win_surf = -1
 #else
-    IF ( ASSOCIATED(array_2d)   )  DEALLOCATE( array_2d )
-    IF ( ASSOCIATED(array_2di)  )  DEALLOCATE( array_2di )
-    IF ( ASSOCIATED(array_3d)   )  DEALLOCATE( array_3d )
-    IF ( ASSOCIATED(array_3di4) )  DEALLOCATE( array_3di4 )
-    IF ( ASSOCIATED(array_3di8) )  DEALLOCATE( array_3di8 )
+    IF ( ASSOCIATED( array_2d )   )  DEALLOCATE( array_2d )
+    IF ( ASSOCIATED( array_2di )  )  DEALLOCATE( array_2di )
+    IF ( ASSOCIATED( array_3d )   )  DEALLOCATE( array_3d )
+    IF ( ASSOCIATED( array_3di4 ) )  DEALLOCATE( array_3di4 )
+    IF ( ASSOCIATED( array_3di8 ) )  DEALLOCATE( array_3di8 )
 #endif
 
